/* keymap.c generated by valac 0.18.0.110-5650, the Vala compiler
 * generated from keymap.vala, do not modify */

/*
 * Copyright (C) 2011-2013 Daiki Ueno <ueno@gnu.org>
 * Copyright (C) 2011-2013 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define KKC_TYPE_KEYMAP (kkc_keymap_get_type ())
#define KKC_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_KEYMAP, KkcKeymap))
#define KKC_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_KEYMAP, KkcKeymapClass))
#define KKC_IS_KEYMAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_KEYMAP))
#define KKC_IS_KEYMAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_KEYMAP))
#define KKC_KEYMAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_KEYMAP, KkcKeymapClass))

typedef struct _KkcKeymap KkcKeymap;
typedef struct _KkcKeymapClass KkcKeymapClass;
typedef struct _KkcKeymapPrivate KkcKeymapPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define KKC_TYPE_KEY_EVENT (kkc_key_event_get_type ())
#define KKC_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KKC_TYPE_KEY_EVENT, KkcKeyEvent))
#define KKC_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), KKC_TYPE_KEY_EVENT, KkcKeyEventClass))
#define KKC_IS_KEY_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KKC_TYPE_KEY_EVENT))
#define KKC_IS_KEY_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), KKC_TYPE_KEY_EVENT))
#define KKC_KEY_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), KKC_TYPE_KEY_EVENT, KkcKeyEventClass))

typedef struct _KkcKeyEvent KkcKeyEvent;
typedef struct _KkcKeyEventClass KkcKeyEventClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _KkcKeymap {
	GObject parent_instance;
	KkcKeymapPrivate * priv;
	GeeMap* entries;
};

struct _KkcKeymapClass {
	GObjectClass parent_class;
};

typedef enum  {
	KKC_KEY_EVENT_FORMAT_ERROR_PARSE_FAILED,
	KKC_KEY_EVENT_FORMAT_ERROR_KEYSYM_NOT_FOUND
} KkcKeyEventFormatError;
#define KKC_KEY_EVENT_FORMAT_ERROR kkc_key_event_format_error_quark ()

static gpointer kkc_keymap_parent_class = NULL;

GType kkc_keymap_get_type (void) G_GNUC_CONST;
enum  {
	KKC_KEYMAP_DUMMY_PROPERTY
};
void kkc_keymap_set (KkcKeymap* self, const gchar* key, const gchar* command);
GQuark kkc_key_event_format_error_quark (void);
KkcKeyEvent* kkc_key_event_new_from_string (const gchar* key, GError** error);
KkcKeyEvent* kkc_key_event_construct_from_string (GType object_type, const gchar* key, GError** error);
GType kkc_key_event_get_type (void) G_GNUC_CONST;
gchar* kkc_key_event_to_string (KkcKeyEvent* self);
gchar* kkc_keymap_lookup_key (KkcKeymap* self, KkcKeyEvent* key);
KkcKeyEvent* kkc_keymap_where_is (KkcKeymap* self, const gchar* command);
KkcKeymap* kkc_keymap_new (void);
KkcKeymap* kkc_keymap_construct (GType object_type);
static void kkc_keymap_finalize (GObject* obj);


void kkc_keymap_set (KkcKeymap* self, const gchar* key, const gchar* command) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	g_return_if_fail (command != NULL);
	{
		const gchar* _tmp0_;
		KkcKeyEvent* _tmp1_;
		KkcKeyEvent* ev;
		GeeMap* _tmp2_;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp0_ = key;
		_tmp1_ = kkc_key_event_new_from_string (_tmp0_, &_inner_error_);
		ev = _tmp1_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
				goto __catch10_kkc_key_event_format_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp2_ = self->entries;
		_tmp3_ = kkc_key_event_to_string (ev);
		_tmp4_ = _tmp3_;
		_tmp5_ = command;
		gee_map_set (_tmp2_, _tmp4_, _tmp5_);
		_g_free0 (_tmp4_);
		_g_object_unref0 (ev);
	}
	goto __finally10;
	__catch10_kkc_key_event_format_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = key;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_warning ("keymap.vala:29: can't get key event from string %s: %s", _tmp6_, _tmp8_);
		_g_error_free0 (e);
	}
	__finally10:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


gchar* kkc_keymap_lookup_key (KkcKeymap* self, KkcKeyEvent* key) {
	gchar* result = NULL;
	GeeMap* _tmp0_;
	KkcKeyEvent* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gpointer _tmp4_ = NULL;
	gchar* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (key != NULL, NULL);
	_tmp0_ = self->entries;
	_tmp1_ = key;
	_tmp2_ = kkc_key_event_to_string (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_map_get (_tmp0_, _tmp3_);
	_tmp5_ = (gchar*) _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}


KkcKeyEvent* kkc_keymap_where_is (KkcKeymap* self, const gchar* command) {
	KkcKeyEvent* result = NULL;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_ = NULL;
	GeeMapIterator* iter;
	GeeMapIterator* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (command != NULL, NULL);
	_tmp0_ = self->entries;
	_tmp1_ = gee_map_map_iterator (_tmp0_);
	iter = _tmp1_;
	_tmp2_ = iter;
	_tmp3_ = gee_map_iterator_first (_tmp2_);
	if (_tmp3_) {
		{
			gboolean _tmp4_;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp5_;
				GeeMapIterator* _tmp8_;
				gpointer _tmp9_ = NULL;
				gchar* _tmp10_;
				const gchar* _tmp11_;
				gboolean _tmp12_;
				_tmp5_ = _tmp4_;
				if (!_tmp5_) {
					GeeMapIterator* _tmp6_;
					gboolean _tmp7_ = FALSE;
					_tmp6_ = iter;
					_tmp7_ = gee_map_iterator_next (_tmp6_);
					if (!_tmp7_) {
						break;
					}
				}
				_tmp4_ = FALSE;
				_tmp8_ = iter;
				_tmp9_ = gee_map_iterator_get_value (_tmp8_);
				_tmp10_ = (gchar*) _tmp9_;
				_tmp11_ = command;
				_tmp12_ = g_strcmp0 (_tmp10_, _tmp11_) == 0;
				_g_free0 (_tmp10_);
				if (_tmp12_) {
					GeeMapIterator* _tmp13_;
					gpointer _tmp14_ = NULL;
					gchar* key;
					_tmp13_ = iter;
					_tmp14_ = gee_map_iterator_get_key (_tmp13_);
					key = (gchar*) _tmp14_;
					{
						const gchar* _tmp15_;
						KkcKeyEvent* _tmp16_;
						KkcKeyEvent* _tmp17_;
						_tmp15_ = key;
						_tmp16_ = kkc_key_event_new_from_string (_tmp15_, &_inner_error_);
						_tmp17_ = _tmp16_;
						if (_inner_error_ != NULL) {
							if (_inner_error_->domain == KKC_KEY_EVENT_FORMAT_ERROR) {
								goto __catch11_kkc_key_event_format_error;
							}
							_g_free0 (key);
							_g_object_unref0 (iter);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
						result = _tmp17_;
						_g_free0 (key);
						_g_object_unref0 (iter);
						return result;
					}
					goto __finally11;
					__catch11_kkc_key_event_format_error:
					{
						GError* e = NULL;
						const gchar* _tmp18_;
						GError* _tmp19_;
						const gchar* _tmp20_;
						e = _inner_error_;
						_inner_error_ = NULL;
						_tmp18_ = key;
						_tmp19_ = e;
						_tmp20_ = _tmp19_->message;
						g_warning ("keymap.vala:47: can't get key event from string %s: %s", _tmp18_, _tmp20_);
						_g_error_free0 (e);
					}
					__finally11:
					if (_inner_error_ != NULL) {
						_g_free0 (key);
						_g_object_unref0 (iter);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_g_free0 (key);
				}
			}
		}
	}
	result = NULL;
	_g_object_unref0 (iter);
	return result;
}


KkcKeymap* kkc_keymap_construct (GType object_type) {
	KkcKeymap * self = NULL;
	self = (KkcKeymap*) g_object_new (object_type, NULL);
	return self;
}


KkcKeymap* kkc_keymap_new (void) {
	return kkc_keymap_construct (KKC_TYPE_KEYMAP);
}


static void kkc_keymap_class_init (KkcKeymapClass * klass) {
	kkc_keymap_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = kkc_keymap_finalize;
}


static void kkc_keymap_instance_init (KkcKeymap * self) {
	GeeHashMap* _tmp0_;
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	self->entries = (GeeMap*) _tmp0_;
}


static void kkc_keymap_finalize (GObject* obj) {
	KkcKeymap * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, KKC_TYPE_KEYMAP, KkcKeymap);
	_g_object_unref0 (self->entries);
	G_OBJECT_CLASS (kkc_keymap_parent_class)->finalize (obj);
}


GType kkc_keymap_get_type (void) {
	static volatile gsize kkc_keymap_type_id__volatile = 0;
	if (g_once_init_enter (&kkc_keymap_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (KkcKeymapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) kkc_keymap_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (KkcKeymap), 0, (GInstanceInitFunc) kkc_keymap_instance_init, NULL };
		GType kkc_keymap_type_id;
		kkc_keymap_type_id = g_type_register_static (G_TYPE_OBJECT, "KkcKeymap", &g_define_type_info, 0);
		g_once_init_leave (&kkc_keymap_type_id__volatile, kkc_keymap_type_id);
	}
	return kkc_keymap_type_id__volatile;
}



